import { OrderedMap } from 'immutable';
import { Reducible, Action, Dispatch } from 'pretur.redux';
import { PageInstance } from './pageInstance';
import { Pages, PageInstantiationData } from './pages';
export declare function deisolate<A extends Action<any, any>>(action: A): A;
export interface NavigatorPageReplaceOptions {
    toRemoveMutex: string;
    toInsertData: PageInstantiationData<any>;
}
export declare class Navigator implements Reducible {
    private pages;
    private prefix;
    private instances;
    private activePageMutex;
    constructor(pages: Pages, prefix?: string);
    readonly active: PageInstance<any, any, any> | null;
    readonly activeMutex: string | null;
    readonly all: OrderedMap<string, PageInstance<any, any, any>>;
    reduce(action: Action<any, any>): this;
    transit(dispatch: Dispatch, mutex: string | null): void;
    open(dispatch: Dispatch, instantiationData: PageInstantiationData<any>): void;
    replace(dispatch: Dispatch, toRemoveMutex: string, toInsertData: PageInstantiationData<any>): void;
    close(dispatch: Dispatch, mutex: string): void;
    load(dispatch: Dispatch): void;
    clear(dispatch: Dispatch): void;
}
